<?php
/************************************************************/
/*                        GagaTemplate                      */
/*                      /\                    */
/*                                                          */
/*                        Version 2.0                       */
/*                                                          */
/*                       Octobre 2006                       */
/*                                                          */
/*                 By gaga26 (gaga26@gmail.com)             */
/*                                                          */
/*       Ce scrtp est libre, vous pouvez le copier, le      */
/*       modifier, le redistribuer, ...                     */
/*                                                          */
/*            Have fun                                      */
/*                                                          */
/*                                     Gaga26               */
/*                                                          */
/************************************************************/

class gagatemplate
{
	//les balises
		var $balises = array(
			'var' => array('{$', '}'),								//balises des vars
			'begin_block' => array('<!-- BEGIN ', ' -->'),			//balises du dbut des blocks
			'end_block' => array('<!-- END ', ' -->'),				//balises de la fin des blocks
			'include' => array('{include file="', '"}'),			//balises de la fin des blocks
			'condition' => array('{if(', ')}', '{else}', '{/if}'),	//balises des condition
			);
	//les dossier
		var $template_dir = 'templates/';	//dossier des fichiers templates	
		var $this_dir;					    //dossier actuel
		var $cache_dir = 'cache/';			//dossier des fichier mis en cache
	
	//var pour les blocks et vars
		var $blocks = array();				//tableau contenant les blocks
		var $variables = array();			//tableau contenant les variables
	
	//var pour le cache
		var $cache = false;					//activation de la mise en cache
		var $cache_time = 60;				//temps du cache en secondes
	
	//var pour le temps d'execution
		var $temps_tpl = array();			//temps de cration par templates
		var $temps = array(
			'balises' => 0,				//
			'assign_var' => 0,			////
			'assign_block' => 0,		//////
			'parse_var_total' => 0,		////////
			'parse_block_total' => 0,	////////// temps pour les diffrentes fonctions
			'clean_cache_dir' => 0,		////////
			'include_total' => 0,		//////
			'condition_total' => 0,		////
			'parse_total' => 0); 		//
	
	//message d'erreur
		var $error_display = true;									//activer l'affichache des erreurs
		var $error_msg = '<br /><b>Gagatemplate error :</b><br />';	//le dbut des messages d'erreur
		var $fichier_actuel;										//le fichier en train d'tre compil
		
	//Pour dfinir o on se trouve par rapport  la racine du site
	function gagatemplate($dir = '')
	{	
		$this->this_dir = $dir;
	}
	
	//Pour calcul le temps d'exectution
	function float_time()
	{
		$microtime = explode(' ', microtime());					// rcupre et spare microtime
		return (float)($microtime[0]+(float)$microtime[1]);		//assemble secondes et micro-seconde
	}
	
	//Pour modifier les balises
	function balises($nom, $array)
	{
		$debut = $this->float_time();//pr le temps d'execution
		
		if(isset($this->balises[$nom]))//si la cl du tableau existe
			if(count($array) == count($this->balises[$nom]))//si il y a le mme nombre d'entrs
				$this->balises[$nom] = $array;//si c'est correct, on modifier les balises
			elseif($this->error_diplay)
				echo $this->error_msg.'Renommage des balises <i>'.$nom.'</i> incorrect !<br /><br />';
		elseif($this->error_diplay)
			echo $this->error_msg.'Les balises <i>'.$nom.'</i> n\'existe pas !<br /><br />';
		
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps['balises'] += ($fin-$debut);//pr le temps d'execution	
	}

	//Pout assigner les variables
	function assign($vars, $valeur = null)
	{
		$debut = $this->float_time();//pr le temps d'execution
		
		if(is_array($vars)) 						//si les variables sont envoyes sous forme de tableau
			foreach($vars as $cle => $value)		//on lit le tableau
				$this->variables[$cle] = $value;	//on assign les vars
		else
			$this->variables[$vars] = $valeur;		//on assign les vars
		
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps['assign_var'] += ($fin-$debut);//pr le temps d'execution	
	}
	
	//pour assginer les blocks et les sous-blocks
	function assign_block($nom, $vars = array())
	{
		$debut = $this->float_time();//pr le temps d'execution
	
		if(strstr($nom, '.'))//si on assign un sous-block
		{
			$explode = explode('.', $nom);//on spare le block du sous-block
			
			if(count($explode) > 2 && $this->error_diplay)//si on a affaire avec un sous-sous-block ou autre...
				exit($this->error_msg.'Gagatemplates ne supporte pas plus que sous-block<br /><br />');
			
			$num_block = count($this->blocks[$explode[0]])-1;//numro du block actuel (nb de boucle)
			
			$this->blocks[$explode[0]][$num_block][$explode[1]][] = $vars;//on assign les vars
			
		}else				
			$this->blocks[$nom][] = $vars; //dclaration du block
			
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps['assign_block'] += ($fin-$debut);//pr le temps d'execution	
	}
	
	//fonction pour savoir si un fichier et toujours en cache
	function is_in_cache($file)
	{
		$fichier_tpl = $this->this_dir.$this->template_dir.$file;//le lien vers le fichier tpl
		$nom_fichier = preg_replace('!^(.+)/(.+)(\..+)$!', '$2', $file);//le nom du fichier sans l'extention
		$fichier_cache = $this->this_dir.$this->cache_dir.$nom_fichier.'-'.filemtime($fichier_tpl).'.txt';//le nom du fichier cache

		if(!is_file($fichier_cache) || (filemtime($fichier_cache) < (time()-$this->cache_time)))//si le fichier n'est pas en cache
			return false;
		
		return true;//sinon 
	}
	
	//fonction pour compiler le fichier
	function parse($file)
	{
		$debut = $this->float_time();//pr le temps d'execution
		$fichier_tpl = $this->this_dir.$this->template_dir.$file;//le lien vers le fichier tpl
		$this->fichier_actuel = $fichier_tpl;//on dfini le fichier en train d'tre compil pour les ventuels messages d'erreur
		if(is_file($fichier_tpl))//si le fichier templates existe
		{						
			if($this->cache)//si la mise en cache est active
			{
				$nom_fichier = preg_replace('!^(.+)/(.+)(\..+)$!', '$2', $file);//le nom du fichier sans l'extention
				$fichier_cache = $this->this_dir.$this->cache_dir.$nom_fichier.'-'.filemtime($fichier_tpl).'.txt';//le lien vers le fichier cache
							
				if(!is_file($fichier_cache) || (filemtime($fichier_cache) < (time()-$this->cache_time)))//si il faut compil a nouveau le fichier cache
				{
					$contenu = file_get_contents($fichier_tpl);//rcupration du contenu du fichier
					$contenu = $this->parse_include($contenu);//parse des include
					$contenu = $this->parse_block($contenu);//parse des blocks
					$contenu = $this->parse_var($contenu);//parse des vars
					$contenu = $this->parse_condition($contenu);//pour parser les conditions
					
					@unlink($fichier_cache);//on supprimer le fichier cache si il existe dj
					$handle= @fopen($fichier_cache, 'w'); //on ouvre le fichier cache en mode criture
					
					if($handle === false && $this->error_diplay)//si l'ouverture  chou
						exit($this->error_msg.'Le <b>Dossier cache</b> n\'est pas ouvert en criture !<br /><br />');		
									
					fwrite($handle, $contenu);//on crit dans le fichier cache
					fclose($handle);// on ferme le fichier
				}
				
				echo file_get_contents($fichier_cache); // on affiche le fichier cache
			}else{
				
				$contenu = file_get_contents($fichier_tpl);//rcupration du contenu du fichier
				
				$contenu = $this->parse_include($contenu);//parse des include
			
				$contenu = $this->parse_block($contenu);//parse des blocks
			
				$contenu = $this->parse_var($contenu);//parse des vars
				$contenu = $this->parse_condition($contenu);//pour parser les conditions

				echo $contenu; // on affiche le contenu
			}
		
		}else
			echo $this->error_msg.'Le fichier <i>'.$file.'</i> n\'existe pas !<br /><br />';
						
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps_tpl[$file] = ($fin-$debut);//pr le temps d'execution	
		$this->temps['parse_total'] += ($fin-$debut);//pr le temps d'execution	
	}
	
	//fonction pour compiler le fichier
	function parse_admin($file)
	{
		$debut = $this->float_time();//pr le temps d'execution
		
		$fichier_tpl = '../templates/'.$file;//le lien vers le fichier tpl
		
		$this->fichier_actuel = $fichier_tpl;//on dfini le fichier en train d'tre compil pour les ventuels messages d'erreur
		
		if(is_file($fichier_tpl))//si le fichier templates existe
		{						
			if($this->cache)//si la mise en cache est active
			{
				$nom_fichier = preg_replace('!^(.+)/(.+)(\..+)$!', '$2', $file);//le nom du fichier sans l'extention
				$fichier_cache = $this->this_dir.$this->cache_dir.$nom_fichier.'-'.filemtime($fichier_tpl).'.txt';//le lien vers le fichier cache
							
				if(!is_file($fichier_cache) || (filemtime($fichier_cache) < (time()-$this->cache_time)))//si il faut compil a nouveau le fichier cache
				{
				
				$contenu = file_get_contents($fichier_tpl);//rcupration du contenu du fichier
				
				$contenu = $this->parse_include($contenu);//parse des include
				
				$contenu = $this->parse_block($contenu);//parse des blocks
				
				$contenu = $this->parse_var($contenu);//parse des vars
				
				$contenu = $this->parse_condition($contenu);//pour parser les conditions
			
					@unlink($fichier_cache);//on supprimer le fichier cache si il existe dj
					
					$handle= @fopen($fichier_cache, 'w'); //on ouvre le fichier cache en mode criture
					
					if($handle === false && $this->error_diplay)//si l'ouverture  chou
						exit($this->error_msg.'Le <b>Dossier cache</b> n\'est pas ouvert en criture !<br /><br />');		
									
					fwrite($handle, $contenu);//on crit dans le fichier cache
					fclose($handle);// on ferme le fichier
				}
				
				echo file_get_contents($fichier_cache); // on affiche le fichier cache
			}else{			
				$contenu = file_get_contents($fichier_tpl);//rcupration du contenu du fichier
				
				$contenu = $this->parse_include_admin($contenu);//parse des include
			
				$contenu = $this->parse_block($contenu);//parse des blocks
			
				$contenu = $this->parse_var($contenu);//parse des vars
			
				$contenu = $this->parse_condition($contenu);//pour parser les conditions
			
				echo $contenu; // on affiche le contenu
			}	
		}else
			echo $this->error_msg.'Le fichier <i>'.$file.'</i> n\'existe pas !<br /><br />';
						
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps_tpl[$file] = ($fin-$debut);//pr le temps d'execution	
		$this->temps['parse_total'] += ($fin-$debut);//pr le temps d'execution	
	}
	
	//pour compiler les includes
	function parse_include($contenu)
	{
		$debut = $this->float_time();//pr le temps d'execution
		if(!function_exists('include_file')) //dclaration de la fonction qui va inclure les fichier
		{		
			define('THIS_DIR', $this->this_dir); 		//
			define('TEMPLATE_DIR', $this->template_dir);////cela peut paratre farfelu, mais je n'ais rien trouv d'autre !
			define('ERROR_MSG', $this->error_msg);		//
			
			function include_file($match)//idem pour cette fonction :p
			{
				if(!is_file(THIS_DIR.TEMPLATE_DIR.$match[1]) && $this->error_display)//si le fichier  inclure existe
					echo ERROR_MSG.'Le fichier<i>'.$match[1].'</i> n\'existe pas !<br /><br />';
				else
					return file_get_contents(THIS_DIR.TEMPLATE_DIR.$match[1]);//on return le contenu du fichier
			}
		}
		$contenu = preg_replace_callback('`'.$this->del_meta($this->balises['include'][0]).'(.+)'.$this->del_meta($this->balises['include'][1]).'`',	'include_file', $contenu);//recherche des fichiers  inclure
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps['include_total'] += ($fin-$debut);//pr le temps d'execution
		
		return $contenu;
	}
	
	//pour compiler les includes
	function parse_include_admin($contenu)
	{
		$debut = $this->float_time();//pr le temps d'execution
		if(!function_exists('include_file')) //dclaration de la fonction qui va inclure les fichier
		{		
			define('THIS_DIR', $this->this_dir); 		//
			define('TEMPLATE_DIR', '../templates/');////cela peut paratre farfelu, mais je n'ais rien trouv d'autre !
			define('ERROR_MSG', $this->error_msg);		//
			
			function include_file($match)//idem pour cette fonction :p
			{
				if(!is_file(THIS_DIR.TEMPLATE_DIR.$match[1]) && $this->error_display)//si le fichier  inclure existe
					echo ERROR_MSG.'Le fichier<i>'.$match[1].'</i> n\'existe pas !<br /><br />';
				else
					return file_get_contents(THIS_DIR.TEMPLATE_DIR.$match[1]);//on return le contenu du fichier
			}
		}
		$contenu = preg_replace_callback('`'.$this->del_meta($this->balises['include'][0]).'(.+)'.$this->del_meta($this->balises['include'][1]).'`',	'include_file', $contenu);//recherche des fichiers  inclure
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps['include_total'] += ($fin-$debut);//pr le temps d'execution
		
		return $contenu;
	}
	
	//pour compiler les vars
	function parse_var($contenu)
	{
		$debut = $this->float_time();//pr le temps d'execution

		foreach($this->variables as $var => $valeur)//on liste les vars
		{
			$search[] = $this->balises['var'][0].$var.$this->balises['var'][1];//on cre une entr avec le texte  rechercher
			$replace[] = $valeur === null ? ' ' : $valeur;//idem pour le texte de remplacement
		}		
		
		$contenu = str_replace($search, $replace, $contenu);//on remplace les vars par leur valeur		
		
		if(preg_match('`'.$this->del_meta($this->balises['var'][0]).'(.+)'.$this->del_meta($this->balises['var'][1]).'`iU', $contenu, $match) && $this->error_display)//si il y  toujours une vars non-compile dans le fichier tpl
			echo $this->error_msg.'La variable <i>'.$match[1].'</i> n\'a pas t dclare dans le fichier '.$this->fichier_actuel.'<br /><br />';
		
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps['parse_var_total'] += ($fin-$debut);//pr le temps d'execution
		
		return $contenu;
	}
	

	//pour compiler les blcok et sous-block
	function parse_block($contenu, $blocks = NULL)
	{
		$debut = $this->float_time();//pr le temps d'execution
		
		if($blocks === NULL) //si ce n''est pas un sous-block
			$blocks = $this->blocks;//on dfini la vars blocks par le tableau principal des blocks
		
		foreach($blocks as $nom => $count)//on lit le tableau des blocks
		{
			if(preg_match('`^(.*)'.$this->balises['begin_block'][0].$nom.$this->balises['begin_block'][1].'(.+)'.$this->balises['end_block'][0].$nom.$this->balises['end_block'][1].'(.*)$`isU', $contenu, $match))//recherche du block $nom et explode du texte par la fonction preg_match
			{
				$contenu_block = $match[2];//on dfini le contenu du block
				$contenu_final = ''; //on initialise le contenu final pour vit les erreurs
				
				foreach($blocks[$nom] as $count => $vars)//on lit le tableau du block $nom
				{
					$new_contenu = $contenu_block;//on dfini le nouveau contenu
					
					foreach($vars as $var => $valeur)//on lit les vars du block $nom
					{
						if(is_array($valeur))//si la vars est un tableau, c'est qu'on a  fair avec un sous-block
							$new_contenu = $this->parse_block($new_contenu, $blocks[$nom][$count]);//on recommence la fonction du dbut avec comme argument le sous-block
						else{
							$replace[] = $valeur;//on cre une entr avec le texte  rechercher
							$search[] = $this->balises['var'][0].$var.$this->balises['var'][1];//idem pour le texte de remplacement
						}
						
					}					
					$new_contenu = str_replace($search, $replace, $new_contenu);//on remplace les vars par leur valeur	
					
					if(preg_match('`'.$this->del_meta($this->balises['var'][0]).'(.+)'.$this->del_meta($this->balises['var'][1]).'`iU', $new_contenu, $matches) && $this->error_display)//si il y  toujours une vars non-compile dans le block
						if(!array_key_exists($matches[1], $this->variables))//si la variables n'est pas dfini dans les variables autres que les variables du block
							echo $this->error_msg.'La variable <i>'.$matches[1].'</i> n\'a pas t dclare dans un block dans le fichier '.$this->fichier_actuel.'<br /><br />';
					
					$search = array();//on remet $search  zro vu qu'on se trouve dans une boucle
					$replace = array();//idem pour $replace
					
					$contenu_final .= $new_contenu;//on ajout le nouveau contenu au contenu final
				}				
				
				$contenu = $match[1].$contenu_final.$match[3]; //assemblage des l'avant_block, du block et de l'aprs block
			
			}	
		}
		
		if(preg_match('`'.$this->del_meta($this->balises['begin_block'][0]).'(.+)'.$this->del_meta($this->balises['begin_block'][1]).'`', $contenu, $match) && $this->error_display)//si un block non-compil se trouve toujours dans le fichier tpl
			echo $this->error_msg.'Le block <i>'.$match[1].'</i> n\'a pas t dclar dans le fichier '.$this->fichier_actuel.'<br /><br />';
		
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps['parse_block_total'] += ($fin-$debut);//pr le temps d'execution
		
		return $contenu;
	}
	
	//pour compiler les condition
	function parse_condition($contenu)
	{
		$debut = $this->float_time();//pr le temps d'execution
		
		if(!function_exists('parse_if'))//toujours ma technique farfelue :p
		{
			define('balise_else', $this->del_meta($this->balises['condition'][2]));
			
			function parse_if($match)
			{
				eval('$condition = (bool)('.$match[1].') ? true : false;');//on value la condition	
				if(preg_match('`^(.+)'.balise_else.'(.+)$`sU', $match[2], $match_else))//si il y a un else dans la condition
				{
					if($condition)//si la condition est juste
						$texte = $match_else[1];
					else
						$texte = $match_else[2];
						
				}else{
					if($condition)//si la condition est juste
						$texte = $match[2];
					else
						$texte = null;
				}
				return $texte;				
			}			
		}
		$contenu = preg_replace_callback('`'.$this->del_meta($this->balises['condition'][0]).'(.+)'.$this->del_meta($this->balises['condition'][1]).'(.+)'.$this->del_meta($this->balises['condition'][3]).'`sU', 'parse_if', $contenu);//on recherche les conditions  compiler
		return $contenu;
	}
	
	//Pour ntoyer le dosier des fichiers mis en cache
	function clean_cache_dir()
	{
		$debut = $this->float_time();//pr le temps d'execution
		
		$dir = dir($this->cache_dir);//on ouvre le dossier
		$array_file = array();//on initialise le tableau des fichiers supprimer
		
		while(false !== ($file = readdir($dir)))//on lit le dossier
		{
			$array_file[] = $file;//on ajoute le fichier au fichier dtruit
			unlink($file);//on dtruit le fichier
		}
		
		$dir->close; //on ferme le dossier
		
		
		$fin = $this->float_time();//pr le temps d'execution
		$this->temps['clean_cache_dir'] += ($fin-$debut);//pr le temps d'execution
		
		return $array_file;
	}
	
	//function pour supprimer les mtacaractre (utilie pour utilis les regex)
	function del_meta($contenu)
	{
		return str_replace(array('\\', '#', '!', '^', '$', '(', ')', '[', ']', '{', '}', '?', '+', '*', '.'),//recherche des mtacaratres
			array('\\\\', '\#', '\!', '\^', '\$', '\(', '\)', '\[', '\]', '\{', '\}', '\?', '\+', '\*', '\.'),//on met un antislashe devant
			$contenu);
	}
	
	//fonction de debugage
	function debug($url_dir, $decimal = 5)
	{
		$contenu = file_get_contents($this->this_dir.'libs/debug.tpl');//on rcupere le contenu
		$class = 'color1';//on initialise la couleur de fond
		
		if(count($this->blocks) !== 0)//si il y a au moins un block
			foreach($this->blocks as $nom => $valeur)//on lit le tabeau des blocks
				$this->assign_block('debug_blocks', array('nom' => $nom, 'valeur' => count($valeur), 'class' => $class = $class == 'color1' ? 'color2' : 'color1'));
		else
			$this->assign_block('debug_blocks', array('nom' => 'aucun block', 'valeur' => ' ', 'class' =>'color1'));
			
		if(count($this->variables) !== 0)//si il y a au moins une variables
			foreach($this->variables as $nom => $valeur)//on lit le tableau
				$this->assign_block('debug_variables', array('nom' => $nom, 'valeur' => htmlentities($valeur), 'class' => $class = $class == 'color1' ? 'color2' : 'color1'));
		else
			$this->assign_block('debug_blocks', array('nom' => 'aucune variable', 'valeur' => ' ', 'class' =>'color1'));
		
		foreach($this->temps as $nom => $valeur)//on lit le tableau des temps d'execution par fonction
			$this->assign_block('debug_temps', array('nom' => $nom, 'valeur' => round($valeur, $decimal), 'class' => $class = $class == 'color1' ? 'color2' : 'color1'));
	
		foreach($this->temps_tpl as $nom => $valeur)//on lit le tableau des temps d'execution par fichier
			$this->assign_block('debug_temps', array('nom' => '<i>'.$nom.'</i>', 'valeur' => round($valeur, $decimal), 'class' => $class = $class == 'color1' ? 'color2' : 'color1'));
	
		$contenu = $this->parse_block($contenu);//on compile les blocks dfini ci-dessus
		
		@unlink($this->this_dir.$this->cache_dir.'debug.php');//on supprime le fichier si il existe dj
		$fichier = fopen($this->this_dir.$this->cache_dir.'debug.php', 'w');//on ouvre le fichier en criture
		fwrite($fichier, $contenu);//on crit dans le fichier
		fclose($fichier);//on ferme le fichier
		
		echo '<script language="javascript" type="text/javascript">
<!--
	window.open(\''.$url_dir.$this->cache_dir.'debug.php\', \'nom fenetre\', \'width=600, height=800,scrollbars=yes\');
-->
</script>';//on affiche le pop-up de la fonction debug
	}
}
$tpl = new gagatemplate();
?>
